# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class ContentLibrary(pulumi.CustomResource):
    description: pulumi.Output[str]
    """
    A description of the Content Library.
    """
    name: pulumi.Output[str]
    """
    The name of the Content Library.
    """
    storage_backings: pulumi.Output[list]
    """
    The [managed object reference ID][docs-about-morefs] on which to store Content Library
    items.
    """
    def __init__(__self__, resource_name, opts=None, description=None, name=None, storage_backings=None, __props__=None, __name__=None, __opts__=None):
        """
        The `.ContentLibrary` resource can be used to manage Content Libraries.

        > **NOTE:** This resource requires vCenter and is not available on direct ESXi
        connections.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-vsphere/blob/master/website/docs/r/content_library.html.markdown.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: A description of the Content Library.
        :param pulumi.Input[str] name: The name of the Content Library.
        :param pulumi.Input[list] storage_backings: The [managed object reference ID][docs-about-morefs] on which to store Content Library
               items.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['description'] = description
            __props__['name'] = name
            if storage_backings is None:
                raise TypeError("Missing required property 'storage_backings'")
            __props__['storage_backings'] = storage_backings
        super(ContentLibrary, __self__).__init__(
            'vsphere:index/contentLibrary:ContentLibrary',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, description=None, name=None, storage_backings=None):
        """
        Get an existing ContentLibrary resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: A description of the Content Library.
        :param pulumi.Input[str] name: The name of the Content Library.
        :param pulumi.Input[list] storage_backings: The [managed object reference ID][docs-about-morefs] on which to store Content Library
               items.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["description"] = description
        __props__["name"] = name
        __props__["storage_backings"] = storage_backings
        return ContentLibrary(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

